# Interface StructureViewerInterface<R, L, S>

#### Type Parameters

- #### R

- #### L

- #### S

#### Hierarchy

- StructureViewerPublicInterface<R, L>
- ViewerCallbackManagerInterface
  - StructureViewerInterface

#### Implemented by

- StructureViewer

- Defined in src/RcsbFvStructure/StructureViewerInterface.ts:36

#####
Index

### Properties

init

### Methods

cameraFocus
clear
clearFocus
clearSelection
colorComponent
createComponent
displayComponent
exportLoadedStructures
getComponentSet
isComponent
load
modelChange
pluginCall
removeComponent
removeStructure
resetCamera
select
setFocus
subscribeHover
subscribeModelChange
subscribeRepresentationChange
subscribeSelection
unsubscribe

## Properties

### init

init: ((stateManager, args) => void)

#### Type declaration

- - (stateManager, args): void

  - #### Parameters

    - ##### stateManager: RcsbFvStateInterface

    - ##### args: S

    #### Returns void

- Defined in src/RcsbFvStructure/StructureViewerInterface.ts:37

## Methods

### cameraFocus

- cameraFocus(modelId, labelAsymId, positions, operatorName?): void

- #### Parameters

  - ##### modelId: string

  - ##### labelAsymId: string

  - ##### positions: number[]

  - ##### `Optional` operatorName: string

  #### Returns void

  Inherited from StructureViewerPublicInterface.cameraFocus

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:67
- cameraFocus(modelId, labelAsymId, begin, end, operatorName?): void

- #### Parameters

  - ##### modelId: string

  - ##### labelAsymId: string

  - ##### begin: number

  - ##### end: number

  - ##### `Optional` operatorName: string

  #### Returns void

  Inherited from StructureViewerPublicInterface.cameraFocus

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:68

### clear

- clear(): Promise<void>

- #### Returns Promise<void>

  Inherited from StructureViewerPublicInterface.clear

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:63

### clearFocus

- clearFocus(): void

- #### Returns void

  Inherited from StructureViewerPublicInterface.clearFocus

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:66

### clearSelection

- clearSelection(mode, option?): void

- #### Parameters

  - ##### mode: "select" | "hover"

  - ##### `Optional` option: SaguaroChain

  #### Returns void

  Inherited from StructureViewerPublicInterface.clearSelection

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:64

### colorComponent

- colorComponent(componentLabel, color): Promise<void>

- #### Parameters

  - ##### componentLabel: string

  - ##### color: "uniform" | "occupancy" | "element-index" | "element-symbol" | "shape-group" | "uncertainty" | "atom-id" | "carbohydrate-symbol" | "chain-id" | "entity-id" | "entity-source" | "model-index" | "structure-index" | "molecule-type" | "secondary-structure" | "operator-name" | "unit-index" | "residue-name" | "cartoon" | "hydrophobicity" | "illustrative" | "operator-hkl" | "partial-charge" | "polymer-id" | "polymer-index" | "sequence-id" | "trajectory-index" | "volume-segment" | "volume-value" | "external-volume"

  #### Returns Promise<void>

  Inherited from StructureViewerPublicInterface.colorComponent

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:74

### createComponent

- createComponent(componentLabel, modelId, labelAsymId, begin, end, representationType, operatorName?): Promise<void>

- #### Parameters

  - ##### componentLabel: string

  - ##### modelId: string

  - ##### labelAsymId: string

  - ##### begin: number

  - ##### end: number

  - ##### representationType: "label" | "line" | "orientation" | "carbohydrate" | "cartoon" | "ellipsoid" | "backbone" | "ball-and-stick" | "gaussian-surface" | "gaussian-volume" | "molecular-surface" | "point" | "putty" | "spacefill"

  - ##### `Optional` operatorName: string

  #### Returns Promise<void>

  Inherited from StructureViewerPublicInterface.createComponent

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:69
- createComponent(componentLabel, modelId, labelAsymId, representationType, operatorName?): Promise<void>

- #### Parameters

  - ##### componentLabel: string

  - ##### modelId: string

  - ##### labelAsymId: string

  - ##### representationType: "label" | "line" | "orientation" | "carbohydrate" | "cartoon" | "ellipsoid" | "backbone" | "ball-and-stick" | "gaussian-surface" | "gaussian-volume" | "molecular-surface" | "point" | "putty" | "spacefill"

  - ##### `Optional` operatorName: string

  #### Returns Promise<void>

  Inherited from StructureViewerPublicInterface.createComponent

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:70
- createComponent(componentLabel, residues, representationType): Promise<void>

- #### Parameters

  - ##### componentLabel: string

  - ##### residues: SaguaroPosition[]

  - ##### representationType: "label" | "line" | "orientation" | "carbohydrate" | "cartoon" | "ellipsoid" | "backbone" | "ball-and-stick" | "gaussian-surface" | "gaussian-volume" | "molecular-surface" | "point" | "putty" | "spacefill"

  #### Returns Promise<void>

  Inherited from StructureViewerPublicInterface.createComponent

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:71
- createComponent(componentLabel, residues, representationType): Promise<void>

- #### Parameters

  - ##### componentLabel: string

  - ##### residues: SaguaroRange[]

  - ##### representationType: "label" | "line" | "orientation" | "carbohydrate" | "cartoon" | "ellipsoid" | "backbone" | "ball-and-stick" | "gaussian-surface" | "gaussian-volume" | "molecular-surface" | "point" | "putty" | "spacefill"

  #### Returns Promise<void>

  Inherited from StructureViewerPublicInterface.createComponent

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:72

### displayComponent

- displayComponent(componentLabel): boolean

- #### Parameters

  - ##### componentLabel: string

  #### Returns boolean

  Inherited from StructureViewerPublicInterface.displayComponent

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:77
- displayComponent(componentLabel, visibilityFlag): void

- #### Parameters

  - ##### componentLabel: string

  - ##### visibilityFlag: boolean

  #### Returns void

  Inherited from StructureViewerPublicInterface.displayComponent

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:78

### exportLoadedStructures

- exportLoadedStructures(): Promise<void>

- #### Returns Promise<void>

  Inherited from StructureViewerPublicInterface.exportLoadedStructures

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:80

### getComponentSet

- getComponentSet(): Set<string>

- #### Returns Set<string>

  Inherited from StructureViewerPublicInterface.getComponentSet

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:75

### isComponent

- isComponent(componentLabel): boolean

- #### Parameters

  - ##### componentLabel: string

  #### Returns boolean

  Inherited from StructureViewerPublicInterface.isComponent

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:73

### load

- load(loadConfig): Promise<undefined | L>

- #### Parameters

  - ##### loadConfig: R

  #### Returns Promise<undefined | L>

  Inherited from StructureViewerPublicInterface.load

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:57
- load(loadConfig): Promise<(undefined | L)[]>

- #### Parameters

  - ##### loadConfig: R[]

  #### Returns Promise<(undefined | L)[]>

  Inherited from StructureViewerPublicInterface.load

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:58

### modelChange

- modelChange(): void

- #### Returns void

  Inherited from ViewerCallbackManagerInterface.modelChange

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:51

### pluginCall

- pluginCall(f): void

- #### Parameters

  - ##### f: ((plugin) => void)

    - - (plugin): void

      - #### Parameters

        - ##### plugin: PluginContext

        #### Returns void

  Inherited from ViewerCallbackManagerInterface.pluginCall

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:53

### removeComponent

- removeComponent(componentLabel?): Promise<void>

- #### Parameters

  - ##### `Optional` componentLabel: string

  #### Returns Promise<void>

  Inherited from StructureViewerPublicInterface.removeComponent

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:76

### removeStructure

- removeStructure(removeConfig): Promise<void>

- #### Parameters

  - ##### removeConfig: R | R[]

  #### Returns Promise<void>

  Inherited from StructureViewerPublicInterface.removeStructure

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:59

### resetCamera

- resetCamera(): void

- #### Returns void

  Inherited from StructureViewerPublicInterface.resetCamera

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:79

### select

- select(modelId, labelAsymId, begin, end, mode, operation, operatorName?): void

- #### Parameters

  - ##### modelId: string

  - ##### labelAsymId: string

  - ##### begin: number

  - ##### end: number

  - ##### mode: "select" | "hover"

  - ##### operation: "set" | "add"

  - ##### `Optional` operatorName: string

  #### Returns void

  Inherited from StructureViewerPublicInterface.select

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:60
- select(selection, mode, operation): void

- #### Parameters

  - ##### selection: SaguaroPosition[]

  - ##### mode: "select" | "hover"

  - ##### operation: "set" | "add"

  #### Returns void

  Inherited from StructureViewerPublicInterface.select

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:61
- select(selection, mode, operation): void

- #### Parameters

  - ##### selection: SaguaroRange[]

  - ##### mode: "select" | "hover"

  - ##### operation: "set" | "add"

  #### Returns void

  Inherited from StructureViewerPublicInterface.select

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:62

### setFocus

- setFocus(modelId, labelAsymId, begin, end, operatorName?): void

- #### Parameters

  - ##### modelId: string

  - ##### labelAsymId: string

  - ##### begin: number

  - ##### end: number

  - ##### `Optional` operatorName: string

  #### Returns void

  Inherited from StructureViewerPublicInterface.setFocus

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:65

### subscribeHover

- subscribeHover(): Subscription

- #### Returns Subscription

  Inherited from ViewerCallbackManagerInterface.subscribeHover

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:48

### subscribeModelChange

- subscribeModelChange(): Subscription

- #### Returns Subscription

  Inherited from ViewerCallbackManagerInterface.subscribeModelChange

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:50

### subscribeRepresentationChange

- subscribeRepresentationChange(): Subscription

- #### Returns Subscription

  Inherited from ViewerCallbackManagerInterface.subscribeRepresentationChange

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:47

### subscribeSelection

- subscribeSelection(): Subscription

- #### Returns Subscription

  Inherited from ViewerCallbackManagerInterface.subscribeSelection

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:49

### unsubscribe

- unsubscribe(): void

- #### Returns void

  Inherited from ViewerCallbackManagerInterface.unsubscribe

  - Defined in src/RcsbFvStructure/StructureViewerInterface.ts:52

Generated using TypeDoc